#ifndef __UNIPAY_H
#define __UNIPAY_H
#ifndef __UNIPAY__
#define __UNIPAYLIB__ __declspec(dllimport)
#else
#define __UNIPAYLIB__ __declspec(dllexport)
#endif
#define BYTE unsigned char
extern "C" 
{
	#define FAIL								0
	#define SUCCESS								1
	#define PARAMETER_ERR						99
	#define KEYS_NOT_LOADED						100
	#define PAN_ERROR							101
	#define ENCRYPTION_DECRYPTION_ERROR			102
	#define NO_ADMIN_KEY						103
	#define ADMIN_KEY_STOP						104
	#define KSN_ERROR							105
	#define GET_AUTHENTICATION_CODE_ERROR		106
	#define VALIDATE_AUTHENTICATION_CODE_ERROR	107
	#define ENCRYPT_DECRYPT_DATA_ERROR		  	108
	#define NOT_SUPPORT_KEY_TYPE			  	109
	#define KEY_INDEX_ERROR					  	110
	#define STEP_ERROR							111
	#define NO_SERIAL_NUMBER				  	112	
	#define INVALID_COMMAND						113
	#define NOT_SUPPORT_COMMAND					114
	#define PIN_DUKPT_STOP					  	115
	#define TIME_OUT							116
	#define NO_CARD_DATA						117
	#define MAGII_NO_RESPONSE					118
	#define NO_CARD_SEATED						119
	#define ICC_POWER_UP_ERROR					120
	#define ICC_COMMUNICATION_TIMEOUT			121
	#define ICC_COMMUNICATION_ERROR				122 
	#define CAPDU_FORMAT_ERROR					123 
	#define LOWER_POWER							124 
	#define IO_LINE_LOW							125 
	#define PORT_OPENED							200
	#define PORT_CLOSED							201	
	#define MSR_MODEL							202	


	
	__UNIPAYLIB__ BYTE WINAPI UniPay_OpenHID(UINT auiVid, UINT auiPid);
	__UNIPAYLIB__ BYTE WINAPI UniPay_Close();
	__UNIPAYLIB__ BYTE WINAPI UniPay_GetFirmware(char *sFirmware, int *length);
	__UNIPAYLIB__ BYTE WINAPI UniPay_GetSerialNumber(char *sSerialNum, int *length);
	__UNIPAYLIB__ BYTE WINAPI UniPay_GetModelNumber(char *sModelNum, int *length);
	__UNIPAYLIB__ BYTE WINAPI UniPay_Reset();
	__UNIPAYLIB__ BYTE WINAPI UniPay_SetRemoteKeyTimeOut(int m_iTime);
	__UNIPAYLIB__ BYTE WINAPI UniPay_GetRemoteKeyTimeOut(int *m_iTime);
	__UNIPAYLIB__ BYTE WINAPI UniPay_SmartGetICCReaderStatus(unsigned char *m_bStatus);
	__UNIPAYLIB__ BYTE WINAPI UniPay_SmartPowerOn(unsigned char *m_PPS_ATR, int *length);
	__UNIPAYLIB__ BYTE WINAPI UniPay_SmartPowerOff();
	__UNIPAYLIB__ BYTE WINAPI UniPay_SmartExchangeAPDU(unsigned char *m_bAPDU, int *length);
	__UNIPAYLIB__ BYTE WINAPI UniPay_SmartExchangeR_APDUEncryption(unsigned char *m_bAPDU, int *length);
	__UNIPAYLIB__ BYTE WINAPI UniPay_SmartGetKSN(unsigned char *m_bKSN);
	__UNIPAYLIB__ BYTE WINAPI UniPay_SmartExchangeAPDUEncryption(unsigned char *m_bAPDU, int *length);
	__UNIPAYLIB__ BYTE WINAPI UniPay_SmartSetKeyType(unsigned char m_bKType);
	__UNIPAYLIB__ BYTE WINAPI UniPay_SmartGetKeyType(unsigned char *m_bKType);
	__UNIPAYLIB__ BYTE WINAPI UniPay_SmartSetEncryptionMode(unsigned char m_bEMode);
	__UNIPAYLIB__ BYTE WINAPI UniPay_SmartGetEncryptionMode(unsigned char *m_bEMode);
	__UNIPAYLIB__ BYTE WINAPI UniPay_SmartDefaultAll();
	__UNIPAYLIB__ BYTE WINAPI UniPay_SmartReviewAll(unsigned char *m_bKType, unsigned char *m_bMode);
	__UNIPAYLIB__ BYTE WINAPI UniPay_EnableMSR(unsigned char m_bTrack, unsigned char *m_bData, int *length);
	__UNIPAYLIB__ BYTE WINAPI UniPay_CancelMSR();
	__UNIPAYLIB__ BYTE WINAPI UniPay_ReviewAllMSRSetting(unsigned char *m_bSet, int *length);
	__UNIPAYLIB__ BYTE WINAPI UniPay_DefaultAllMSRSetting();
	__UNIPAYLIB__ BYTE WINAPI UniPay_SetMSRCommonSetting(unsigned char m_bFunctionID, unsigned char m_bValue);
	__UNIPAYLIB__ BYTE WINAPI UniPay_GetMSRCommonSetting(unsigned char m_bFunctionID, unsigned char *m_bValue);





}
#endif