// UniPay_SDK_DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "UniPay_SDK_Demo.h"
#include "UniPay_SDK_DemoDlg.h"
#include "UniPay_SDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUniPay_SDK_DemoDlg dialog

CUniPay_SDK_DemoDlg::CUniPay_SDK_DemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUniPay_SDK_DemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUniPay_SDK_DemoDlg)
	m_strRes = _T("");
	m_strData = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUniPay_SDK_DemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUniPay_SDK_DemoDlg)
	DDX_Text(pDX, IDC_EDIT_RESULT, m_strRes);
	DDX_Text(pDX, IDC_EDIT_CARDDATA, m_strData);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUniPay_SDK_DemoDlg, CDialog)
	//{{AFX_MSG_MAP(CUniPay_SDK_DemoDlg)
	ON_MESSAGE(WM_SWITCH_UPDATE, OnSwitchUpdate)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_OPEN, OnBtnOpen)
	ON_BN_CLICKED(IDC_BTN_CLOSE, OnBtnClose)
	ON_BN_CLICKED(IDC_BTN_ENABLE, OnBtnEnable)
	ON_BN_CLICKED(IDC_BTN_CANCEL, OnBtnCancel)
	ON_BN_CLICKED(IDC_BUTTON_VERSION, OnButtonVersion)
	ON_BN_CLICKED(IDC_BUTTON_REMOTE, OnButtonRemote)
	ON_BN_CLICKED(IDC_BUTTON_ICCSTATUS, OnButtonIccstatus)
	ON_BN_CLICKED(IDC_BUTTON_POWERON, OnButtonPoweron)
	ON_BN_CLICKED(IDC_BUTTON_POWEROFF, OnButtonPoweroff)
	ON_BN_CLICKED(IDC_BUTTON_APDU, OnButtonApdu)
	ON_BN_CLICKED(IDC_BUTTON_KSN, OnButtonKsn)
	ON_BN_CLICKED(IDC_BUTTON_KEY, OnButtonKey)
	ON_BN_CLICKED(IDC_BUTTON_MODE, OnButtonMode)
	ON_BN_CLICKED(IDC_BUTTON_DEFAULT, OnButtonDefault)
	ON_BN_CLICKED(IDC_BUTTON_COMMON, OnButtonCommon)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUniPay_SDK_DemoDlg message handlers

BOOL CUniPay_SDK_DemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CUniPay_SDK_DemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CUniPay_SDK_DemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

LRESULT CUniPay_SDK_DemoDlg::OnSwitchUpdate(WPARAM wp, LPARAM lp)
{
	UpdateData(FALSE);	
	return 0;
}

void CUniPay_SDK_DemoDlg::ErrorShow(unsigned char result,CString str)
{
	CString strR;
	strR.Format(":Res = %d",result);
	m_strRes =str + strR;
	UpdateData(false);

}
void CUniPay_SDK_DemoDlg::OnBtnOpen() 
{
	// TODO: Add your control notification handler code here
	res = 0;
	res = UniPay_OpenHID(0x0acd, 0x3110);
	ErrorShow(res,"Open");

	
}

void CUniPay_SDK_DemoDlg::OnBtnClose() 
{
	// TODO: Add your control notification handler code here
	res  = 0;
	res = UniPay_Close();
	ErrorShow(res,"Close");
}

static UINT ThreadProc_MSR( LPVOID pParam )
{

	CUniPay_SDK_DemoDlg* pthis = (CUniPay_SDK_DemoDlg*)pParam;
	pthis->res = 0;
	unsigned char rec[512];
	int length = 0;
	pthis->res = UniPay_EnableMSR(0x37, rec, &length);
	if(pthis->res == 1)
	{
		CString str,temp;
		for(int i = 0; i < length; i++)
		{
			temp.Format("%02X ",rec[i]);
			str += temp;
		}
		pthis->m_strData = str;

	}
	else
	{	
		CString temp;
		temp.Format("Enable MSR:Res = %d", pthis->res);
		pthis->m_strRes = temp;
	}
	
	
	pthis->SendMessage(WM_SWITCH_UPDATE, 0, 0);
	return 0;
}

void CUniPay_SDK_DemoDlg::OnBtnEnable() 
{
	// TODO: Add your control notification handler code here
	AfxBeginThread(ThreadProc_MSR, this);
	m_strData = "";
	SendMessage(WM_SWITCH_UPDATE, 0, 0);
	
}

void CUniPay_SDK_DemoDlg::OnBtnCancel() 
{
	// TODO: Add your control notification handler code here
	res = UniPay_CancelMSR();
	ErrorShow(res,"Cancel MSR");
	UpdateData(FALSE);
}

void CUniPay_SDK_DemoDlg::OnButtonVersion() 
{
	// TODO: Add your control notification handler code here
	char Version[128];
	m_strData = "";
	int length = 0;
	res = UniPay_GetFirmware(Version, &length);	
//	res = UniPay_GetSerialNumber(Version, &length);	
//	res = UniPay_GetModelNumber(Version, &length);	
	if(res == 1)
	{
		for(int i = 0; i < length; i++)
		{
			m_strData += Version[i];			
		}
	}
	ErrorShow(res,"Get Version");
	UpdateData(FALSE);
}

void CUniPay_SDK_DemoDlg::OnButtonRemote() 
{
	// TODO: Add your control notification handler code here
	int m_bTime;
	res = UniPay_SetRemoteKeyTimeOut(200);
	res = UniPay_GetRemoteKeyTimeOut(&m_bTime);
	if(res == 1)
	{
		m_strData.Format("Timeout = %d", m_bTime);
	}
	ErrorShow(res,"Remote Key Injection Timeout");
	UpdateData(FALSE);
}

void CUniPay_SDK_DemoDlg::OnButtonIccstatus() 
{
	// TODO: Add your control notification handler code here
	unsigned char m_bStatus = 0x00;
	res = UniPay_SmartGetICCReaderStatus(&m_bStatus);
	if(res == 1)
	{
		m_strData.Format("ICC Reader Status = %d", m_bStatus);
	}
	ErrorShow(res,"Get ICC Reader Status");
	UpdateData(FALSE);
}

void CUniPay_SDK_DemoDlg::OnButtonPoweron() 
{
	// TODO: Add your control notification handler code here
	unsigned char m_PPS_ATR[256];
	int length = 0;
	m_strData = "";
	res = UniPay_SmartPowerOn(m_PPS_ATR, &length);
	if(res == 1)
	{
		CString temp;
		for(int i = 0; i < length; i++)
		{
			temp.Format("%02X ", m_PPS_ATR[i]);
			m_strData += temp;			
		}

	}
	ErrorShow(res,"PowerON");
	UpdateData(FALSE);
}

void CUniPay_SDK_DemoDlg::OnButtonPoweroff() 
{
	// TODO: Add your control notification handler code here
	res = UniPay_SmartPowerOff();
	ErrorShow(res,"PowerOFF");
	UpdateData(FALSE);
}

void CUniPay_SDK_DemoDlg::OnButtonApdu() 
{
	// TODO: Add your control notification handler code here
	unsigned char m_bAPDU[128] = {0x00, 0xA4, 0x00, 0x00, 0x02, 0x30, 0x40};
	int length = 7;
	m_strData = "";
//	res = UniPay_SmartExchangeAPDU(m_bAPDU, &length);
//	res = UniPay_SmartExchangeR_APDUEncryption(m_bAPDU, &length);
	res = UniPay_SmartExchangeAPDUEncryption(m_bAPDU, &length);
	if(res == 1)
	{
		CString temp;
		for(int i = 0; i < length; i++)
		{
			temp.Format("%02X ", m_bAPDU[i]);
			m_strData += temp;			
		}

	}
	ErrorShow(res,"Exchange APDU");
	UpdateData(FALSE);
}

void CUniPay_SDK_DemoDlg::OnButtonKsn() 
{
	// TODO: Add your control notification handler code here
	unsigned char m_bKSN[10];
	m_strData = "";

	res = UniPay_SmartGetKSN(m_bKSN);
	if(res == 1)
	{
		CString temp;
		for(int i = 0; i < 10; i++)
		{
			temp.Format("%02X ", m_bKSN[i]);
			m_strData += temp;			
		}

	}
	ErrorShow(res,"Get KSN");
	UpdateData(FALSE);
}

void CUniPay_SDK_DemoDlg::OnButtonKey() 
{
	// TODO: Add your control notification handler code here
	m_strData = "";
	unsigned char m_bKey;
	res = UniPay_SmartSetKeyType(0x00);
	res = UniPay_SmartGetKeyType(&m_bKey);

	if(res == 1)
	{
		m_strData.Format("Key Type = %02X", m_bKey);
	}
	ErrorShow(res,"Key Type");
	UpdateData(FALSE);

}

void CUniPay_SDK_DemoDlg::OnButtonMode() 
{
	// TODO: Add your control notification handler code here
	m_strData = "";
	unsigned char m_bMode;
	res = UniPay_SmartSetEncryptionMode(0x00);
	res = UniPay_SmartGetEncryptionMode(&m_bMode);

	if(res == 1)
	{
		m_strData.Format("Encryption Mode = %02X", m_bMode);
	}
	ErrorShow(res,"Encryption Mode");
	UpdateData(FALSE);
}

void CUniPay_SDK_DemoDlg::OnButtonDefault() 
{
	// TODO: Add your control notification handler code here
	m_strData = "";
	int length = 0;
	unsigned char m_bSet[256];
//	res = UniPay_DefaultAllMSRSetting();
	res = UniPay_ReviewAllMSRSetting(m_bSet, &length);


	if(res == 1)
	{
		CString temp;
		for(int i = 0; i < length; i++)
		{
			temp.Format("%02X ", m_bSet[i]);
			m_strData += temp;			
		}
	}
	ErrorShow(res,"Default All");
	UpdateData(FALSE);
}

void CUniPay_SDK_DemoDlg::OnButtonCommon() 
{
	// TODO: Add your control notification handler code here

	m_strData = "";
	unsigned char m_bSet;
	res = UniPay_SetMSRCommonSetting(0x49, 0x05);

	res = UniPay_GetMSRCommonSetting(0x49, &m_bSet);

	if(res == 1)
	{
		m_strData.Format("Encryption Mode = %02X", m_bSet);
	}
	ErrorShow(res,"Common Setting");
	UpdateData(FALSE);
}
